<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_add_category.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }

require ( "../config.php" );
require ( "admin_common.php" );
require ( "../includes/mysql.php" );
require ( "../global_config.php" );
require ( "admin_interface.php" );
require ( "admin_validate_form.php" );

///////////////////// start of functions ////////////////////////////////////

function check_details ( $category, $sub )
    {    
    global $db, $type;

	$result = check_field ( $category, ucwords ( $sub ) . " Category", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }        
	
	if ( $type != "edit" )
		{
		//Ensure that this is not a duplicate record
		$query = "SELECT id 
					FROM mnl_categories 
					WHERE category='$category'";
		
		$message = "This Category already exists";

		if ( $sub == "sub" )
			{
			global $parent_category;
			$message = "This Sub Category already exists";
			$query = "SELECT id 
						FROM mnl_categories 
						WHERE category='$parent_category'
						AND sub_category='$category'";
			}
		
		$db->query ( $query );
		if ( $db->num_rows > 0 )
			{
			$message = create_error_message ( $message );
			return array('error' => true, 'error_msg' => $message );		
			}
		}

    return array('error' => false, 'error_msg' => "" );
    }


///////////////////// end of functions ////////////////////////////////////

global $db;
$mode   = $_GET['mode'];
$cat_id = $_GET['cat_id'];
$type	= $_GET['type'];
$sub	= $_GET['sub'];

$page			= "add_category";
$button_text	= "Add this " . ucwords ( $sub ) . " Category";
$heading		= "<b>ADD A NEW " . strtoupper ( $sub ) . " CATEGORY</b>";
$category_text	= "The New " . ucwords ( $sub ) . " Category";

if ( $sub == "sub" )
	{
	$page = "add_sub_category";
	$query = "SELECT * 
	FROM mnl_categories
	WHERE id='$cat_id'";
	$result				= $db->get_row ( $query );
	$parent_category	= $result->category;
	$old_sub_category	= $result->sub_category;
	}

if ( $type == "edit" )
	{
	$page			= "edit_category";	
	$button_text	= "Post Changes";
	$heading		= "<b>EDIT THIS CATEGORY</b>";
	$category_text	= "Category";
	
	if ( $sub == "sub" )
		{
		$page			= "add_sub_category";
		$heading		= "<b>EDIT THIS SUB CATEGORY</b>";
		$category_text	= "Sub Category";

		$query = "SELECT id FROM mnl_links
					WHERE category='$parent_category'
					AND sub_category='$old_sub_category'";
		$db->query ( $query );

		$links_exist = false;
		if ( $db->num_rows > 0 )
			{
			$links_exist = true;
			}
		}
	
	$query = "SELECT * 
				FROM mnl_categories
				WHERE id='$cat_id'";
	$result		= $db->get_row ( $query );
	$category	= $result->category;
	$approved	= $result->approved;

	$can_edit = false;
	if ( $result->sub_category == "" )
		{
		$can_edit = true;
		}
	}

if ( $mode == "confirm" )
	{
    $category		= $_POST['category'];
    $sub_category	= $_POST['sub_category'];
	$approved		= $_POST['approved'];

	$file_cat	= str_replace ( " ", "_", $category );	

	if ( $sub == "sub" )
		{
		$file_cat	= str_replace ( " ", "_", $sub_category );
		}

	$form_check = check_details ( $file_cat, $sub );
	$date_added = date( "j F Y" );

	if ( $form_check[error] == false )
		{
		if ( $type == "edit" )
			{
			if ( $sub != "sub" )
				{
				$query = "UPDATE mnl_categories
							SET category='$file_cat',
							approved='$approved'
							WHERE id='$cat_id'";
				$message1 = "Category updated";
				$message2 = "Category <b>" . str_replace ( "_", " ", $category ) . " </b>has been successfully updated";
				}
			else
				{
				$query = "UPDATE mnl_categories
							SET sub_category='$file_cat',
							approved='$approved'
							WHERE id='$cat_id'";
				$message1 = "Sub Category updated";
				$message2 = "Sub Category <b>" . str_replace ( "_", " ", $sub_category ) . " </b>has been successfully updated";
				}
			
			}
		else
			{
			if ( $sub != "sub" )
				{
				$query = "INSERT INTO mnl_categories ( 
								category,
								date_added,
								approved ) 
								
								VALUES ( '$file_cat',
								'$date_added',
								'yes')";		
				$message1 = "Category added successfully";
				$message2 = "Category <b>" . str_replace ( "_", " ", $category ) . " </b>has been successfully added to the database";
				}
			else
				{
				//find out if this category has sub categories

				$query = "SELECT * 
							FROM mnl_categories
							WHERE category='$parent_category'
							AND sub_category IS NULL";
				$db->query ( $query );
				if ( $db->num_rows == 0 )
					{
					//  It is OK to insert this sub category record
					$query = "INSERT INTO mnl_categories ( 
								category,
								sub_category,
								date_added,
								approved ) 
								
								VALUES ( '$parent_category',
								'$file_cat',
								'$date_added',
								'yes')";		
					}
				else
					{
					// have to perform an update query
					$query = "Update mnl_categories
								SET sub_category='$file_cat',
								approved='yes'
								WHERE category='$parent_category'";
					}
				$message1 = "Sub Category added successfully";
				$message2 = "Sub Category <b>" . str_replace ( "_", " ", $sub_category ) . " </b>has been successfully added to the database";
				}
			}

		$db->query ( $query );
		print_message ( $message1, $message2 );
		die;	
		}
	}

admin_page_header();

//Start the main boy table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

breadcrumbs( $page );
$bgcolour = "#FFFFFF";
$column1_width = "30%";
$column2_width = "70%";
$field_width = "35";

// error found - display the error message here
if ( $form_check[error_msg] != "") 
    {
    echo $form_check[error_msg] . "<br>\n";
    }

echo "<form method=\"post\" action=\"admin_add_category.php?mode=confirm&amp;type=" . $type . "&amp;cat_id=" . $cat_id . "&amp;sub=" . $sub . "\">\n";
echo "<table width=\"90%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td class=\"tbody\" colspan=\"2\" align=\"center\">$heading</td>\n";
echo "</tr>\n";
if ( $can_edit || $type != "edit" )
	{
	if ( $sub == "sub" )
		{
		// Display the category field
		display_text ( $bgcolour, $column1_width, $column2_width, "Parent Category", str_replace ( "_", " ", $parent_category ) );	
		}
	else
		{
		// The category name field
		text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>" . $category_text . "</b>", "category", $category, $field_width );
		}
	}
else
	{
	if ( $sub != "sub" )
		{
		echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
		echo "<td class=\"tbody\" colspan=\"2\" align=\"left\">You cannot edit the category name as it has dependent sub categories";
		echo "<input type=\"hidden\" name=\"category\" value=\"$category\">\n";	
		echo "</td>\n";
		echo "</tr>\n";
		// Display the category field
		display_text ( $bgcolour, $column1_width, $column2_width, "Category", str_replace ( "_", " ", $category ) );	
		}
	else
		{
		// Display the category field
		display_text ( $bgcolour, $column1_width, $column2_width, "Category", str_replace ( "_", " ", $parent_category ) );			
		}
	}

if ( $sub == "sub" )
	{
	if ( $links_exist )
		{
		
		echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
		echo "<td class=\"tbody\" colspan=\"2\" align=\"left\">You cannot edit the Sub Category name as it has dependent links";
		echo "<input type=\"hidden\" name=\"category\" value=\"" . $parent_category . "\">\n";	
		echo "<input type=\"hidden\" name=\"sub_category\" value=\"" . $old_sub_category . "\">\n";	
		echo "</td>\n";
		echo "</tr>\n";

		// Display the sub category field
		display_text ( $bgcolour, $column1_width, $column2_width, "Sub Category", str_replace ( "_", " ", $old_sub_category ) );
		}
	else
		{
		
		$show_sub_cat = "";
		if ( $type == "edit" )
			{
			$show_sub_cat = str_replace ( "_", " ", $old_sub_category );
			}		
		// The sub category name field
		text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Sub Category</b>", "sub_category", $show_sub_cat, $field_width );
		}
	}

if ( $type == "edit" )
	{
	// The approve field
	echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
	echo "<td class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Approve this category</b></td>\n";
	echo "<td width=\"$column2_width\" class=\"tbody\">\n";
	echo "<select class=\"formelement\" name=\"approved\">\n";
	if ( $approved == "yes" )
		{
		form_input_select_option( "Yes", "yes", "1" );
		}
	else
		{
		form_input_select_option( "Yes", "yes", "0" );
		}

	if ( $approved == "no" )
		{
		form_input_select_option( "No", "no", "1" );
		}
	else
		{
		form_input_select_option( "No", "no", "0" );
		}
	echo "</select>\n";
	echo "</td>\n";
	echo "</tr>\n";
	}

echo "<tr bgcolor=\"$bgcolour\">\n";
echo "<td colspan=\"2\" class=\"tbody\" align=\"center\">\n";
echo "<input type=\"submit\" class=\"formelement\" name=\"Submit\" value=\"$button_text\">\n";
echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";

echo "</form>\n";
echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );
?>