<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Dynamic Links Engine
// | http://www.cplinks.com
// | Full licence details can be found at http://www.cplinks.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_add_link.php version history:
// | version 1.0 01/06/2004
// | version 1.03 26/10/2004
// +----------------------------------------------------------------------+
//

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }

require ( "../config.php" );
require ( "admin_common.php" );
require ( "../includes/mysql.php" );
require ( "../global_config.php" );
require ( "admin_interface.php" );
require ( "admin_validate_form.php" );

global $db;

function check_form ( $link_type, $title, $website_url, $return_url, $description )
	{

	$result = check_field ( $title, "Link Title", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	

	if ( $website_url == "http://" )
		{
        return array('error' => true, 'error_msg' => create_error_message ( "Please supply a URL for the website" ) );
		}

	$result = check_field ( $website_url, "Your website URL", 1, 150 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

	if ( $link_type == "partner" )
		{
		if ( $return_url == "http://" )
			{
			return array('error' => true, 'error_msg' => create_error_message ( "Please supply a URL for the reciprocal link" ) );
			}

		$result = check_field ( $website_url, "The URL of the reciprocal link", 1, 100 );
		if ( $result[error] == true )
			{
			return array('error' => true, 'error_msg' => $result[error_msg] );
			}		
		}

	$result = check_field ( $description, "The Description", 1, 250 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	
	return array('error' => false, 'error_msg' => "" );	
	}

$cat		= $_GET['category'];
$sub_cat	= $_GET['sub_category'];
$mode		= $_GET['mode'];

$category_name		= str_replace ( "_", " ", $cat ); 
$sub_category_name	= str_replace ( "_", " ", $sub_cat );
$heading			= "<b>ADD A NEW LINK FOR " . strtoupper ( $category_name ) . "&nbsp;>&nbsp;" . strtoupper ( $sub_category_name ) . " </b>";
$page				= "add_link";

if ( $mode == "confirm" )
	{
    // trim the input variables
	$link_type		= $_POST['link_type'];
	$link_title		= $_POST['link_title'];
	$website_url	= $_POST['website_url'];
	$return_url		= $_POST['return_url'];
	$description	= trim ( $_POST['description'] );

    $form_check = check_form ( $link_type, $link_title, $website_url, $return_url, $description );
    if ( $form_check[error] == false )
        {
		// Add this record to the mnl_links table
        $date_added = date( "j F Y" );
        $timestamp = time();

		$query = "INSERT INTO mnl_links (
						category,
						sub_category,
						title,
						url,
						description,
						return_url,
						date_added,
						rec_timestamp,
						status,
						approved )

					VALUES (
						'$cat',
						'$sub_cat',
						'$link_title',
						'$website_url',
						'$description',
						'$return_url',
						'$date_added',
						'$timestamp',
						'$link_type',
						'yes')";

		$db->query ( $query );
		print_message ( "This link has been added to the database", "" );
		die;
		}
	else
		{
		$user_message = "<font color=\"red\"><b>SLIGHT PROBLEM:</b></font>&nbsp;" . $form_check[error_msg];	$description = strip_slashes ( $description );
		}
	}

admin_page_header();

//Start the main boy table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

breadcrumbs( $page );
$bgcolour = "#FFFFFF";
$column1_width = "30%";
$column2_width = "70%";
$field_width = "35";

// error found - display the error message here
if ( $form_check[error_msg] != "") 
    {
    echo $form_check[error_msg] . "<br>\n";
    }

echo "<form method=\"post\" action=\"" . $PHP_SELF . "?mode=confirm&amp;category=" . $cat . "&amp;sub_category=" . $sub_cat . "\">\n";
echo "<table width=\"90%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td class=\"tbody\" colspan=\"2\" align=\"center\">$heading</td>\n";
echo "</tr>\n";

//Type of link
$partner_checked = "";
$regular_checked = " checked";

if ( $link_type == "partner" )
	{
	$partner_checked = " checked";
	$regular_checked = "";
	}

echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Type of Link:</b></td>\n";
echo "<td width=\"50%\" class=\"tbody\">Regular <input type=\"radio\" name=\"link_type\" value=\"regular\"" . $regular_checked . ">";
echo "&nbsp;&nbsp;Link Partner <input type=\"radio\" name=\"link_type\" value=\"partner\"" . $partner_checked . ">";
echo "</td>\n";
echo "</tr>\n";

//Title field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Link Title:</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"link_title\" value=\"$link_title\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

//website url field
if ( $website_url == "" )
	{
	$website_url = "http://";
	}
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>The URL of the website:</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"website_url\" value=\"$website_url\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

//Description field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" valign=\"top\" class=\"tbody\"><b>Description of the site:</b>\n";
echo "<td width=\"50%\"><textarea rows=\"6\" name=\"description\" cols=\"35\" class=\"forms\">" . $description . "</textarea>\n";
echo "</td>\n";
echo "</tr>\n";

//return url field
if ( $return_url == "" )
	{
	$return_url = "http://";
	}
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Reciprocal link URL (Optional):</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"return_url\" value=\"$return_url\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Submit Link\" class=\"buttons\"></td>";
echo "</tr>";
echo "</table>";
echo "</form>";

echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );

?>