<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_approve_links.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }

function create_row ( $heading, $text )
	{
	global $bgcolour;
	echo "<tr bgcolor=\"$bgcolour\">\n";
	echo "<td class=\"tbody\">" . $heading . "</td>\n";
	echo "<td class=\"tbody\">" . $text . "</td>\n";
	echo "</tr>\n";
	}

function show_row ( $id, $category, $sub_category, $title, $url, $description, $return_url, $status, $date_added )
	{
	if ( $return_url == "http://" )
		{
		$return_url = "Not Supplied";
		}

	create_row ( "Category", str_replace ( "_", " ", $category ) . " > " . str_replace ( "_", " ", $sub_category ) );
	create_row ( "Title", $title );
	create_row ( "URL", $url );
	create_row ( "Description", $description );
	create_row ( "Status", ucwords ( $status ) );
	create_row ( "Return URL", $return_url );
	create_row ( "Date Added", $date_added );
	create_row ( "Actions", "<a href=\"admin_edit_link.php?id=" . $id . "&amp;type=approve\"><img src=\"images/pencil.gif\" alt=\"Edit this link\" border=\"0\"></a>&nbsp;&nbsp;Edit this link &nbsp;|&nbsp;<a href=\"admin_delete_link.php?type=approve&amp;id=" . $id . "\"><img src=\"images/cross.gif\" alt=\"Delete this link\" border=\"0\"></a> Delete this link" );
	echo "<tr>\n";
	echo "<td class=\"tbody\" bgcolor=\"#FFFFCC\" colspan=2><input type=\"checkbox\" name=\"checkbox[]\" value=\"$id\">&nbsp;&nbsp;Tick this checkbox to approve this link</td>\n";
	echo "</tr>\n";
	}

require ( "../config.php" );
require ( "admin_common.php" );
require ( "../includes/mysql.php" );
require ( "../global_config.php" );
require ( "admin_interface.php" );

$page	= "approve_links";
$mode	= $_GET['mode'];

if ( $mode == "confirm" )
	{
	
	if ( count ( $_POST['checkbox'] ) == 0 )
		{
		print_message ( "There are no new links to approve", "" );
		die;
		}
	$count = 0;
	foreach ( $_POST['checkbox'] as $key=>$val )
		{		
		$count++;
		$query = "update mnl_links set approved='yes' where id = '$val'";
		$db->query ( $query );

		//See if they added an email address and what the link status is
		$query = "SELECT 
					email,
					status 
					FROM mnl_links where id = '$val'";
		$result	= $db->get_row ( $query );
		$email	= $result->email;
		$status = $result->status;
		if ( $email != "" )
			{
			$mail_subject = $CONFIG_VAR['website_name'] . " - Your link has been published";
			$mail_body = "Thank you for submitting your link to " . $CONFIG_VAR['website_name'] . "\n\n";
			$mail_body .= "Your link has been approved and published in our directory.\n\n";
			if ( $status == "partner" )
				{
				$mail_body .= "As a link partner, your link will always be given priority positioning in lists and search results.\n\n";
				}
			$mail_body .= "Regards.\n";
			$mail_body .= $CONFIG_VAR['website_name'] . " admin team";
			$mail_header = "From: " . $CONFIG_VAR['webmaster_email'] . "\r\n";

			mail ( $email, $mail_subject, $mail_body , $mail_header );

			}
		}

	$link_text		= "these new links";
	$header_text	= "links have";
	if ( $count == 1 )
		{
		$link_text		= "this new link";
		$header_text	= "link has";
		}
    
	print_message ( "The new " . $header_text . " been approved", $count . " " . $header_text . " been approved.<br><br>Remember to build the correct link and category pages and also the index page to publish " . $link_text . "." );
    die;
	}

$query	= "SELECT * FROM mnl_links where approved='no'";

$result = $db->get_results ( $query );

if ( $db->num_rows == 0 )
    {
    print_message ( "There are no links to approve", "" );
    die;
    }

admin_page_header();

//Start the main body table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

breadcrumbs( $page );

echo "<form action=\"admin_approve_links.php?mode=confirm\" method=\"post\">";
echo "<table width=\"90%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td class=\"tbody\" align=\"center\" colspan=\"2\"><b>APPROVE NEW LINKS</b></td>\n";
echo "</tr>\n";

$bgcolour = "#FFFFFF";

foreach ( $result as $val )
	{
	show_row ( $val->id, $val->category, $val->sub_category, $val->title, $val->url, $val->description, $val->return_url, $val->status, $val->date_added );
	}
echo "<tr bgcolor=\"$bgcolour\">\n";
echo "<td class=\"tbody\" colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Approve Links\"></td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "</form>\n";

echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );
?>