<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_edit_link.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

function check_form ( $title, $url, $description, $email, $return_url, $status )
	{

	$result = check_field ( $title, "Title", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	
	$result = check_field ( $url, "Web Site URL", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }


	$result = check_field ( $description, "Description", 1, 250 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

	if ( strtolower ( $email ) != "not supplied" )
		{
		$result = validate_email ( $email );
		if ( $result == false )
			{
			$message = create_error_message ( "Your email address must be valid" );
		    return array('error' => true, 'error_msg' =>$message );			
			}
		}
	
	if ( strtolower ( $return_url ) != "not supplied" && $status == "partner" )
		{
		$result = check_field ( $return_url, "Reciprocal URL", 1, 100 );
		if ( $result[error] == true )
			{
			return array('error' => true, 'error_msg' => $result[error_msg] );
			}
		}

	return array('error' => false, 'error_msg' => "" );	
	}

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }

require ( "../config.php" );
require ( "admin_common.php" );
require ( "../includes/mysql.php" );
require ( "../global_config.php" );
require ( "admin_interface.php" );
require ( "admin_validate_form.php" );

$link_id	= $_GET['id'];
$mode		= $_GET['mode'];
$type		= $_GET['type'];

$page	= "edit_link";
$header = "EDIT LINK";

$page	= "edit_manage_link";
if ( $type == "approve" )
	{
	$page	= "edit_approve_link";
	}


if ( $mode == "confirm" )
	{
	$link_id		= $_POST['link_id'];
	$category		= $_POST['category'];
	$sub_category	= $_POST['sub_category'];
	$date_added		= $_POST['date_added'];
	$title			= trim ( $_POST['title'] );
	$url			= trim ( $_POST['url'] );
	$email			= trim ( $_POST['email'] );
	$description	= trim ( $_POST['description'] );
	$return_url		= trim ( $_POST['return_url'] );
	$status			= $_POST['status'];
	$approved		= $_POST['approved'];

	$form_check = check_form ( $title, $url, $description, $email, $return_url, $status );
	if ( $form_check[error] == false )
		{        
		$title			= add_slashes ( $title );
		$description	= add_slashes ( $description );                
	
		//update the link with the edited details
		$query = "UPDATE mnl_links SET
					title			= '$title',
					description		= '$description',
					url				= '$url',
					email			= '$email',
					status			= '$status',
					return_url		= '$return_url',
					approved		= '$approved'
					WHERE id		= '$link_id'";
		
		$db->query ( $query );
		print_message ( "Link Update Complete", "The changes that you have made to the link have been saved" );
		die;
		}
	else
		{
		$title			= strip_slashes ( $title );
		$description	= strip_slashes ( $description );
		}
	}

if ( $mode != "confirm" )
	{
	$query	= "SELECT * FROM mnl_links where id='$link_id'";
	$result = $db->get_row ( $query );

	if ( $db->num_rows == 0 )
		{
		print_message ( "This link could not be found", "" );
		die;
		}

	$category		= $result->category;
	$sub_category	= $result->sub_category;
	$title			= $result->title;
	$url			= $result->url;
	$description	= $result->description;
	$status			= $result->status;
	$email			= $result->email;
	$return_url		= $result->return_url;
	$date_added		= $result->date_added;
	$approved		= $result->approved;
	
	if ( $return_url == "http://" )
		{
		$return_url = "Not Supplied";
		}

	if ( $email == "" )
		{
		$email = "Not Supplied";
		}

	}

admin_page_header();

//Start the main body table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

breadcrumbs( $page );

// error found - display the error message here
if ( $form_check[error_msg] != "") 
    {
    echo $form_check[error_msg] . "<br>\n";
    }

echo "<form action=\"admin_edit_link.php?mode=confirm&amp;type=" . $type . "\" method=\"post\">";
echo "<table width=\"90%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td class=\"tbody\" align=\"center\" colspan=\"2\"><b>" . $header . "</b></td>\n";
echo "</tr>\n";

$bgcolour = "#FFFFFF";
$column1_width = "30%";
$column2_width = "70%";
$field_width = "35";

// Display the Category
display_text ( $bgcolour, $column1_width, $column2_width, "Category", str_replace ( "_", " ", $category ) . " > " . str_replace ( "_", " ", $sub_category ) );


// The link status field
echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
echo "<td class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Status</b></td>\n";
echo "<td width=\"$column2_width\" class=\"tbody\">\n";
echo "<select class=\"formelement\" name=\"status\">\n";
if ( $status == "regular" )
	{
	form_input_select_option( "Regular", "regular", "1" );
	}
else
	{
	form_input_select_option( "Regular", "regular", "0" );
	}

if ( $status == "partner" )
	{
	form_input_select_option( "Partner", "partner", "1" );
	}
else
	{
	form_input_select_option( "Partner", "partner", "0" );
	}
echo "</select>\n";
echo "</td>\n";
echo "</tr>\n";

// The link title field
text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Title</b>", "title", $title, $field_width );

// The link url field
text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Web Site URL</b>", "url", $url, $field_width );

// The link description field
echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
echo "<td class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Description :</b></td>\n";
echo "<td width=\"$column2_width\" class=\"tbody\">\n";
echo "<textarea name=\"description\" cols=\"35\" rows=\"10\" class=\"formelement\">" . $description . "</textarea>\n";
echo "<input type=\"hidden\" name=\"link_id\" value=\"$link_id\">\n";
echo "<input type=\"hidden\" name=\"category\" value=\"$category\">\n";
echo "<input type=\"hidden\" name=\"sub_category\" value=\"$sub_category\">\n";
echo "<input type=\"hidden\" name=\"date_added\" value=\"$date_added\">\n";
echo "</td>\n";
echo "</tr>\n";

// The reciprocal url field
text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Reciprocal Link URL</b>", "return_url", $return_url, $field_width );

// The submitter's email address
text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Email Address</b>", "email", $email, $field_width );

// Display the date added
display_text ( $bgcolour, $column1_width, $column2_width, "Date Entered", $date_added );

// The link approve field
echo "<tr bgcolor=\"" . $bgcolour . "\">\n";
echo "<td class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Approve this link</b></td>\n";
echo "<td width=\"$column2_width\" class=\"tbody\">\n";
echo "<select class=\"formelement\" name=\"approved\">\n";
if ( $approved == "yes" )
	{
	form_input_select_option( "Yes", "yes", "1" );
	}
else
	{
	form_input_select_option( "Yes", "yes", "0" );
	}

if ( $approved == "no" )
	{
	form_input_select_option( "No", "no", "1" );
	}
else
	{
	form_input_select_option( "No", "no", "0" );
	}
echo "</select>\n";
echo "</td>\n";
echo "</tr>\n";

echo "<tr bgcolor=\"$bgcolour\">\n";
echo "<td class=\"tbody\" colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Save Changes\"></td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "</form>\n";

echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );
?>