<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_system.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }

require ( "../config.php" );
require ( "admin_common.php" );
$require = "../global_config.php";
require ( "../includes/mysql.php" );
require ( "admin_interface.php" );
require ( "admin_validate_form.php" );

//suppress all error reports
error_reporting(0);

///////////////////// start of functions ////////////////////////////////////

function check_details ( $website_name, $webmaster_email, $root_directory, $body_width, $main_body_colour, $form_line_colour, $form_bgcolour, $msg_line_colour, $msg_bgcolour, $index_title, $index_keywords, $index_description )
    {    
    global $db;
    
    // Check the website name field
    $result = check_field ( $website_name, "Website Name", 1, 50 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

	// Check the webmaster email field
    $result = check_field ( $webmaster_email, "Webmaster email address", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check the root directory field
    $result = check_field ( $root_directory, "The absolute path to your links directory", 1, 50 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check body width field
    $result = check_field ( $body_width, "Body Width", 1, 4 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check main body colour field
    $result = check_field ( $main_body_colour, "The background colour of the main table", 1, 6 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	
    // Check form line colour colour field
    $result = check_field ( $form_line_colour, "The colour of the form table lines", 1, 6 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check form bgcolour colour field
    $result = check_field ( $form_bgcolour, "The background colour of the form table rows", 1, 6 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check message line colour colour field
    $result = check_field ( $msg_line_colour, "The colour of the message table lines", 1, 6 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check message bgcolour colour field
    $result = check_field ( $msg_bgcolour, "The background colour of the message table rows", 1, 6 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check the index title field
    $result = check_field ( $index_title, "The title meta tag for your index page", 1, 200 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check the index keywords field
    $result = check_field ( $index_keywords, "The keywords meta tag for your index page", 1, 200 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check the index description field
    $result = check_field ( $index_description, "The description meta tag for your index page", 1, 200 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    return array('error' => false, 'error_msg' => "" );
	}


function heading_line( $heading )
    {
    echo "<tr bgcolor=\"#FFFFCC\">\n";
    echo "<td class=\"tbody\" colspan=\"2\" align=\"left\"><b>$heading</b></td>\n";
    echo "</tr>\n";
    }

function form_radio_boxes ( $text, $field_name, $value )
    {
    global $bgcolour, $column1_width, $column2_width;

	echo "<tr bgcolor=\"$bgcolour\">\n";
    echo "<td width=\"$column1_width\" class=\"tbody\" bgcolor=\"" . $bgcolour . "\">$text</td>\n";
    echo "<td width=\"$column2_width\" class=\"tbody\">\n";
    $yes_check = "";
    $no_check = "checked";

    if ( $value == "yes" )
        {
        $yes_check = "checked";
        $no_check = "";
        }
    echo "<input type=\"radio\" name=\"$field_name\" value=\"yes\" ". $yes_check.">Yes\n";
    echo "<input type=\"radio\" name=\"$field_name\" value=\"no\" ". $no_check.">No\n";
	echo "</td>\n";
    echo "</tr>\n";
    }


function config_field_radio_boxes ( $field_name, $value, $text )
    {
	global $bgcolour;

    $yes_check = "";
    $no_check = "checked";

    if ( $value == "yes" )
        {
        $yes_check = "checked";
        $no_check = "";
        }
    echo "<tr bgcolor=\"$bgcolour\">\n";
    echo "<td width=\"30%\" class=\"tbody\">$text</td>\n";

	echo "<td width=\"20%\" class=\"tbody\"><input type=\"radio\" name=\"$field_name\" value=\"yes\" ". $yes_check.">Yes</td>\n";
    echo "<td width=\"20%\" class=\"tbody\"><input type=\"radio\" name=\"$field_name\" value=\"no\" ". $no_check.">No</td>\n";
    echo "</tr>\n";
	}


function form_text_box ( $text, $field_name, $value )
    {
    global $bgcolour, $column1_width, $column2_width;

    echo "<tr bgcolor=\"$bgcolour\">\n";
    echo "<td width=\"$column1_width\" class=\"tbody\" valign=\"top\" bgcolor=\"" . $bgcolour . "\">$text</td>\n";
    echo "<td width=\"$column2_width\" class=\"tbody\">\n";
    echo "<textarea name=\"$field_name\" cols=\"35\" rows=\"5\" class=\"formelement\">$value</textarea>\n";
    echo "</td>\n";
    echo "</tr>\n";
    }

///////////////////// end of functions ////////////////////////////////////

global $db;
$mode = $_GET['mode'];

if ( $mode == "confirm" )
    {
    // create the form variables from each of the POST array elements
    foreach ( $_POST as $k => $v )
        {
        $$k = $v;
        }

	$form_check = check_details ( $_POST['website_name'], $_POST['webmaster_email'], $_POST['root_directory'], $_POST['body_width'], $_POST['main_body_colour'], $_POST['form_line_colour'], $_POST['form_bgcolour'], $_POST['msg_line_colour'], $_POST['msg_bgcolour'], $_POST['index_title'], $_POST['index_keywords'], $_POST['index_description'] );

    if ( $form_check[error] == false )
        {

        $body_width_value = $body_width;
        // builds the body_width_value variable
        if ( $body_width_type == "percent" )
            {
            $body_width_value = $body_width . "%";
            }

        $new = array(	'website_name'					=> strip_slashes ( $_POST['website_name'] ), 
						'webmaster_email'				=> strtolower ( $_POST['webmaster_email'] ),
						'send_webmaster_email'			=> $_POST['send_webmaster_email'],
						'root_directory'				=> strtolower ( $_POST['root_directory'] ),
						'body_width_value'				=> $body_width_value,
						'main_body_colour'				=> strtoupper ( $_POST['main_body_colour'] ),
						'main_body_align'				=> $_POST['main_body_align'],
						'suggest_category'				=> $_POST['suggest_category'],
						'form_line_colour'				=> $_POST['form_line_colour'],
						'form_bgcolour'					=> $_POST['form_bgcolour'],
						'msg_line_colour'				=> $_POST['msg_line_colour'],
						'msg_bgcolour'					=> $_POST['msg_bgcolour'],
						'index_title'					=> $_POST['index_title'],
						'index_keywords'				=> $_POST['index_keywords'],
						'index_description'				=> $_POST['index_description'],
                     );

        foreach( $new as $k => $v )
            {
             // Update the old...
             
             $v = preg_replace( "/'/", "\\'" , $v );
             $v = preg_replace( "/\r/", ""   , $v );
             
             $CONFIG_VAR[ $k ] = $v;
            }
         
         $file_string = "<?php\n";
            
         foreach( $CONFIG_VAR as $k => $v )
            {
             $file_string .= '$CONFIG_VAR['."'".$k."'".']'."\t\t\t=\t'".$v."';\n";
            }
         
         $file_string .= "\n".'?'.'>';   // Question mark + greater than together break syntax hi-lighting in BBEdit 6 :p
         
         if ( $fh = fopen ( $require, 'w' ) )
            {
            fputs ( $fh, $file_string, strlen ( $file_string ) );
            fclose ( $fh );

            $message_1 = "Settings updated";
            $message_2 = "Your system settings have been updated successfully";
            }
         else
            {
            $message_1 = "Error Encountered";
            $message_2 = "Could not open global_config.php for writing - no changes applied. Try changing the CHMOD to 0777";
            }
        $page = "system_setup";
        print_message ( $message_1, $message_2 );
        die;
        }
    }
else
    {
    require $require;
    // initialise the form variables
    $website_name						= $CONFIG_VAR['website_name'];
    $webmaster_email					= $CONFIG_VAR['webmaster_email'];
    $send_webmaster_email				= $CONFIG_VAR['send_webmaster_email'];
	$root_directory						= $CONFIG_VAR['root_directory'];
    $suggest_category					= $CONFIG_VAR['suggest_category'];
	$body_width_value					= $CONFIG_VAR['body_width_value'];
    $main_body_colour					= $CONFIG_VAR['main_body_colour'];
    $main_body_align					= $CONFIG_VAR['main_body_align'];
	$form_line_colour					= $CONFIG_VAR['form_line_colour'];
	$form_bgcolour						= $CONFIG_VAR['form_bgcolour'];
	$msg_line_colour					= $CONFIG_VAR['msg_line_colour'];
	$msg_bgcolour						= $CONFIG_VAR['msg_bgcolour'];
	$index_title						= $CONFIG_VAR['index_title'];
    $index_keywords						= $CONFIG_VAR['index_keywords'];
    $index_description					= $CONFIG_VAR['index_description'];

	}

if ( $body_width_value != "" )
    {
    $body_width_type = "pixels";
    if ( strpos ( $body_width_value, "%" ) )
        {
        $body_width_type = "percent";
        $body_width = substr ( $body_width_value, 0, strpos ( $body_width_value, "%" ) );
        }
    else
        {
        $body_width_type = "pixels";
        $body_width = $body_width_value;    
        }
    }
else
    {
    $body_width_type = "percent";
    $body_width = "100";     
    }

$button_text = "Save these Settings";
$page = "system_setup";

admin_page_header();

//Start the main body table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

breadcrumbs( $page );
$bgcolour = "#FFFFFF";
$heading_bgcolour = "#CCFFFF";
$column1_width = "50%";
$column2_width = "50%";
$field_width = "30";

// error found - display the error message here
if ( $form_check[error_msg] != "") 
    {
    echo $form_check[error_msg] . "<br>\n";
    }

echo "<form method=\"post\" action=\"admin_system.php?mode=confirm\">\n";
echo "<table width=\"90%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";

heading_line ( "General Settings" );

// the web site name field
$text = "<b>Your Website Name :</b><br><span class=\"tbodysmall\">This is the name of your website eg My Link Directory, not your domain name</span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "website_name", $website_name, $field_width );

// the webmaster email field
$text = "<b>Your Webmaster email address :</b>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "webmaster_email", $webmaster_email, $field_width );


// the root directory - default to public_html
if ( $root_directory == "" )
    {
    $root_directory = "public_html";
    }
$text = "<b>The absolute path to your links directory :</b><br><span class=\"tbodysmall\">Most Apache servers use public_html/ as the root directory.  If your links directory is in this folder, use this.  If it is in a sub directory called \"links\" then your absolute path is \"public_html/links\"  <b>Do not add a trailing \"/\"</b></span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "root_directory", $root_directory, $field_width );

// Send webmaster email when links or categories are submitted
if ( $send_webmaster_email == "" )
    {
    $send_webmaster_email = "yes";
    }

form_radio_boxes ( "<b>Send webmaster an email when links or categories are submitted:</b>", "send_webmaster_email", $send_webmaster_email );


// Allow users to suggest categories and sub categories
if ( $suggest_category == "" )
    {
    $suggest_category = "yes";
    }

form_radio_boxes ( "<b>Users can suggest Categories and Sub Categories:</b><br><span class=\"tbodysmall\">Setting this to \"Yes\" means that users may suggest categories and subcategories.  Selecting \"No\" removes the Suggest Category menu choices</span>", "suggest_category", $suggest_category );

heading_line ( "Page Design Settings" );

echo "<tr bgcolor=\"$bgcolour\">\n";
echo "<td width=\"$column1_width\" class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Links directory \"Main Body\" Width :</b><br><span class=\"tbodysmall\">This controls the main table width of the links directory output.</span></td>\n";
echo "<td width=\"$column2_width\" class=\"formelement\">\n";
echo "<input type=\"text\" name=\"body_width\" value=\"$body_width\" class=\"formelement\" size=\"4\">\n";
echo "&nbsp;";
echo "<select class=\"formelement\" name=\"body_width_type\">\n";


if ( $body_width_type == "percent" )
    {
    form_input_select_option( "Percent", "percent", "1" );
    }
else
    {
    form_input_select_option( "Percent", "percent", "0" );
    }

if ( $body_width_type == "pixels" )
    {
    form_input_select_option( "Pixels", "pixels", "1" );
    }
else
    {
    form_input_select_option( "Pixels", "pixels", "0" );
    }

echo "</select>\n";
echo "</td>\n";
echo "</tr>\n";

// This field is the alignment of the main body table
echo "<tr bgcolor=\"$bgcolour\">\n";
echo "<td width=\"$column1_width\" class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>Links directory \"Main Body\" Alignment :</b><br><span class=\"tbodysmall\">This controls the alignment of main table width of the links directory output.  It can be either \"left\" or \"center\", however only set this to \"left\" if you do not want anything in the left and right columns and want your main table displayed on the left hand side.</span></td>\n";
echo "<td width=\"$column2_width\" class=\"formelement\">\n";
echo "<select class=\"formelement\" name=\"main_body_align\">\n";

if ( $main_body_align == "" )
    {
	$main_body_align == "center";
	}

if ( $main_body_align == "center" )
    {
    form_input_select_option( "Center", "center", "1" );
    }
else
    {
    form_input_select_option( "Center", "center", "0" );
    }

if ( $main_body_align == "left" )
    {
    form_input_select_option( "Left", "left", "1" );
    }
else
    {
    form_input_select_option( "Left", "left", "0" );
    }

echo "</select>\n";
echo "</td>\n";
echo "</tr>\n";

// This field specifies the colour of the main body table
if ( $main_body_colour == "" )
    {
    $main_body_colour = "FFFFFF";
    }

$text = "<b>Links directory \"Main Body\" Color :</b><br><span class=\"tbodysmall\">This controls the color of the main table for the links directory output. <b>Do not add the \"#\" character.</b></span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "main_body_colour", $main_body_colour, "6" );

// This field specifies the colour of the lines of the form table
if ( $form_line_colour == "" )
    {
    $form_line_colour = "555555";
    }

$text = "<b>The color of the lines surrrounding the user forms :</b><br><span class=\"tbodysmall\">Do not add the \"#\" character.</span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "form_line_colour", $form_line_colour, "6" );

// This field specifies the colour of the rows of the form table
if ( $form_bgcolour == "" )
    {
    $form_bgcolour = "EEEEEE";
    }

$text = "<b>The color of the rows in the user forms :</b><br><span class=\"tbodysmall\">Do not add the \"#\" character.</span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "form_bgcolour", $form_bgcolour, "6" );


// This field specifies the colour of the lines of the message table
if ( $msg_line_colour == "" )
    {
    $msg_line_colour = "FFFFFF";
    }

$text = "<b>The color of the lines in the user message table :</b><br><span class=\"tbodysmall\">Do not add the \"#\" character.</span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "msg_line_colour", $msg_line_colour, "6" );


// This field specifies the colour of the rows of the message table
if ( $msg_bgcolour == "" )
    {
    $msg_bgcolour = "FFFFFF";
    }

$text = "<b>The color of the rows in the user message table :</b><br><span class=\"tbodysmall\">Do not add the \"#\" character.</span>";
text_input( $bgcolour, "text", $column1_width, $column2_width, $text, "msg_bgcolour", $msg_bgcolour, "6" );


heading_line ( "Index Page Meta Tags" );

$text = "<b>Index Page Title Meta Tag :</b><br><span class=\"tbodysmall\">This is the text that is displayed in your index page title meta tag.  Max 200 characters.</span>";
form_text_box ( $text, "index_title", $index_title );

$text = "<b>Index Page Keywords Meta Tag :</b><br><span class=\"tbodysmall\">This is the text that is displayed in your index page keywords meta tag.  Max 200 characters.</span>";
form_text_box ( $text, "index_keywords", $index_keywords );

$text = "<b>Index Page Description Meta Tag :</b><br><span class=\"tbodysmall\">This is the text that is displayed in your index page description meta tag.  Max 200 characters.</span>";
form_text_box ( $text, "index_description", $index_description );

// The submit button
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td colspan=\"2\" class=\"tbody\" align=\"center\">\n";
echo "<input type=\"submit\" class=\"formelement\" name=\"Submit\" value=\"$button_text\">\n";
echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "</form>\n";

echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );
?>