<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_user.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

// Ensure that the user is logged in
session_start();
if ( $_SESSION['logged_in'] != "true" )
    {
    header ( "location: index.php" );
    exit;
    }


require ( "../config.php" );
require ( "admin_common.php" );
require ( "../includes/mysql.php" );
require ( "../global_config.php" );
require ( "admin_interface.php" );
require ( "admin_validate_form.php" );

///////////////////// start of functions ////////////////////////////////////

function check_details ( $name, $password_1, $password_2 )
    {    
    global $db;
    
    // Check the admin user name field    
    $result = check_field ( $name, "Admin User Name", 1, 50 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check the password_1 field
    $result = check_field ( $password_1, "Admin Password", 1, 50 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

    // Check that the passwords match
    if ( $password_1 != $password_2 )
        {
        $error_message = create_error_message ( "Your passwords do not match" );
        return array('error' => true, 'error_msg' => $error_message );
        }

    return array('error' => false, 'error_msg' => "" );
    }


///////////////////// end of functions ////////////////////////////////////

global $db;
$mode = $_GET['mode'];

$page = "admin_details";

if ( $mode == "confirm" )
    {
    $name           = $_POST['name'];
    $password_1     = $_POST['password_1'];
    $password_2     = $_POST['password_2'];
    
    $form_check = check_details ( $name, $password_1, $password_2 );
    if ( $form_check[error] == false )
        {
        $name = strtolower ( $name );
        $password_1 = md5 ( strtolower ( $password_1 ) );
        $query = "UPDATE mnl_admin 
                SET admin_username='$name', 
                admin_password='$password_1' 
                WHERE id='1'";
        $db->query ( $query );
        print_message ( "Details updated", "Your administrator details have been updated successfully" );
        die;
        }
    }
else
    {
    $query  = "SELECT * FROM mnl_admin WHERE id='1'";
    $result = $db->get_row( $query );
    $name   = $result->admin_username;
    }

admin_page_header();

//Start the main body table
echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#FFFFFF\">\n";
echo "<tr>\n";

admin_side_menu();

echo "<td valign=\"top\">\n";

$button_text = "Save these Settings";

breadcrumbs( $page );
$bgcolour = "#FFFFFF";
$column1_width = "30%";
$column2_width = "70%";
$field_width = "35";

// error found - display the error message here
if ( $form_check[error_msg] != "") 
    {
    echo $form_check[error_msg] . "<br>\n";
    }

echo "<form method=\"post\" action=\"admin_user.php?mode=confirm\">\n";
echo "<table width=\"90%\" height=\"70\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\" bgcolor=\"#555555\" align=\"center\">\n";
echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td class=\"tbody\" colspan=\"2\" align=\"center\"><b>Administrator Details</b></td>\n";
echo "</tr>\n";

// Administrator Name Field
text_input( $bgcolour, "text", $column1_width, $column2_width, "<b>Admin User Name :</b>", "name", $name, $field_width );

// Password 1 field
text_input( $bgcolour, "password", $column1_width, $column2_width, "<b>New Password :</b>", "password_1", $password_1, $field_width );

// Confirm Password field
text_input( $bgcolour, "password", $column1_width, $column2_width, "<b>Confirm New Password :</b>", "password_2", $password_2, $field_width );

echo "<tr bgcolor=\"#EEEEEE\">\n";
echo "<td colspan=\"2\" class=\"tbody\" align=\"center\">\n";
echo "<input type=\"submit\" class=\"formelement\" name=\"Submit\" value=\"$button_text\">\n";
echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";

echo "</form>\n";
//echo "</table>\n";
echo "</td>\n";

//complete the main body table
echo "</tr>\n";
echo "</table>\n";

admin_page_footer( $cplinks_version );
?>