<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | admin_validate_form.php version history:
// | version 1.0 01/06/2004
// +----------------------------------------------------------------------+
//

function of_preg_quote( $str, $delimiter )
{
	$text = preg_quote( $str );
	$text = str_replace( $delimiter, '\\' . $delimiter, $text );
	
	return $text;
}


function add_slashes ( $text )
    {
    if ( !get_magic_quotes_gpc() ) 
        {        
        $text = addslashes( $text );
        }
        return $text;    
    }


function search_for_html ( $text )
    {
    
    require ( "../global_config.php");
    if ( $CONFIG_VAR['allow_html'] == "yes" )
        {
        return true;
        }

    if ( strstr ( $text, "<" ) )
        {
        return false;
        }

    if ( strstr ( $text, ">" ) )
        {
        return false;
        }
    return true;
    }



function create_error_message ( $error_text )
    {
    global $table_width;

    $message = "<table border=\"0\" width=\"90%\" align=\"center\">\n";
    $message .= "<tr><td><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"3\" color=\"#ff0066\"><b>SLIGHT ERROR</b></font></td></tr>\n";
    $message .= "<tr><td><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"2\" color=\"#ff0066\">$error_text</font></td></tr>\n";   
    $message .= "</table>\n";    
    return $message;
    }


function check_field ( $value, $field_name, $min_length, $max_length )
    {
    if ( !empty( $value ) )
	    {
        if ( strlen ( $value ) < $min_length or strlen ( $value ) > $max_length )
            {
            $error_message = $field_name .  " must be longer than " . $min_length . " and shorter than " . $max_length . " characters long";
			$error_message = create_error_message ( $error_message );
            return array('error' => true, 'error_msg' => $error_message );
            }
        else
            {
		    // check for html characters
            if ( !search_for_html ( $value ) )
                {
    			$error_message = create_error_message ( "You cannot use HTML" );
                return array('error' => true, 'error_msg' => $error_message );
                }
            else
                {
                return array('error' => false, 'error_msg' => '');
                }               
            }
        }
    $error_message = $field_name .  " is a required field";
    $error_message = create_error_message ( $error_message );
    return array('error' => true, 'error_msg' => $error_message );
    }


function validate_email ( $email ) 
    {
	return ( ereg( '^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'. '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.' . '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email ) );
    }


function display_text ( $bgcolour, $column1_width, $column2_width, $text, $value )
	{
	echo "<tr bgcolor=\"$bgcolour\">\n";
	echo "<td width=\"$column1_width\" class=\"tbody\" bgcolor=\"" . $bgcolour . "\"><b>" . $text . "</b></td>\n";
	echo "<td width=\"$column2_width\" class=\"tbody\">" . $value . "</td>\n";
	echo "</tr>\n";
	}

function text_input( $bgcolour, $type, $column1_width, $column2_width, $text, $name, $value, $field_width )
    {    
    echo "<tr bgcolor=\"$bgcolour\">\n";
    echo "<td width=\"$column1_width\" class=\"tbody\" bgcolor=\"" . $bgcolour . "\">" . $text . "</td>\n";
    echo "<td width=\"$column2_width\" class=\"tbody\">\n";
    echo "<input type=\"$type\" name=\"$name\" value=\"$value\" class=\"formelement\" size=\"$field_width\">\n";
    echo "</td>\n";
    echo "</tr>\n";
    }


function form_input_select_option( $text, $value, $selected ) 	
    {
	echo "<option value=\"$value\"";
	if ($selected == "1")
		{
		echo " selected";
		}
    echo ">";
	echo "$text</option>\n";	
    }


function clean_text( $text ) 
    { 
    $text = strip_tags( $text ); 
    $text = htmlentities( $text, ENT_QUOTES ); 
    $text = str_replace( "\n", " ", $text ); 
    $text = eregi_replace( " +", " ", $text ); 
    
    //these are optional and strip extra spaces 
    //$text = str_replace( ". ", ".  ", $text ); 
    //$text = str_replace( "? ", "?  ", $text ); 
    //$text = str_replace( "! ", "!  ", $text ); 
    
    $text = trim( $text ); 
    return $text; 
    } 
?>