<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.cplinks.com
// | Full licence details can be found at http://www.cplinks.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | suggest_cat.php version history:
// | version 1.0 01/06/2004
// | version 1.03 26/10/2004
// +-----------------------------------------------------------------------+
// |
// | Should you require bespoke modifications to cpLinks, please contact us at
// | cplinks@medianetrix.com
// |
// +========================================================================+

require ( "version.php" );
require ( "config.php" );
require ( "global_config.php" );
require ( "includes/mysql.php" );
require ( "static_generator/common.php" );

global $db;

function check_form ( $category, $user_email )
	{
	global $db;

	$result = check_field ( $category, "Category", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

	if ( $user_email != "" )
		{
		$result = validate_email ( $user_email );
		if ( $result == false )
			{
			return array('error' => true, 'error_msg' => "Your email address must be valid" );
			}
		}
	
	$category = str_replace ( " ", "_", $category );
	//check that this category is not a duplicate
	$query = "SELECT id 
				FROM mnl_categories
				WHERE category = '$category'";
	$db->query ( $query );
	if ( $db->num_rows > 0 )
		{
		return array('error' => true, 'error_msg' => "This Category already exists" );		
		}

	return array('error' => false, 'error_msg' => "" );	
	}

$mode			= $_GET['mode'];
$form_width		= $page_width - ( $left_column_width + $blank_column_width );

$title			= $CONFIG_VAR['website_name'] . " :: Suggest a category";
$keyword		= "";
$description	= "";
$type			= "index";

//This creates the page header
require ( "templates/mnl_page_header.php" );

// This creates the start of the main body table
echo "<!-- Start of main body table -->\n\n";

echo "<table width=\"" . $CONFIG_VAR['body_width_value'] . "\" align=\"" . $CONFIG_VAR['main_body_align'] . "\" cellspacing=\"0\" border=\"0\" cellpadding=\"0\" bgcolor=\"#" . $CONFIG_VAR['main_body_colour'] . "\">\n";
echo "<tr>\n";

//This creates the left hand column	
require ( "templates/mnl_left_hand_column.php" );

// This creates the middle table
echo "<!-- Start of middle column -->\n\n";
echo "<td valign=\"top\">\n";


$user_message = "Please enter the name of the category.  We only use your email address as a courtesy to inform you when we have approved your suggestion.";

if ( $mode == "confirm" )
	{
    // trim the input variables
	$category		= trim ( $_POST['category'] );
	$user_email		= $_POST['user_email'];

    $form_check = check_form ( $category, $user_email );
    if ( $form_check[error] == false )
        {
		// Add this record to the mnl_categories table
		$category = str_replace ( " ", "_", $category );
        $date_added = date( "j F Y" );
        $timestamp = time();

		$query = "INSERT INTO mnl_categories (
						category,
						sub_category,
						email,
						date_added )

					VALUES (
						'$category',
						null,
						'$user_email',
						'$date_added' )";

		$db->query ( $query );
		$category_id = $db->insert_id;

		if ( $CONFIG_VAR['send_webmaster_email'] == "yes" )
			{
			// send an email to us about the new listing
			$mail_subject = "New category submitted for " . $CONFIG_VAR['website_name'];
			$mail_body = "Category Record Number: " . $category_id . "\n\n";
			$mail_body .= "Category: " . $category . "\n\n";
			$mail_body .= "Email Address: " . $user_email . "\n\n";
			$mail_header = "From: " . $CONFIG_VAR['webmaster_email'] . "\r\n";

			mail ( $CONFIG_VAR['webmaster_email'], $mail_subject, $mail_body , $mail_header );
			}

		// display the thank you

		$message = "Your suggestion has been submitted and we will approve it as soon as possible.";
		if ( $user_email != "" )
			{
			$message .= "<br><br>We will contact you at the email address that you've just supplied (" . $user_email . ") once your category has been approved.";
			}
		
		show_message ( "Thank You", $message );
		die;

		}
	else
		{
		$user_message = "<font color=\"red\"><b>SLIGHT PROBLEM:</b></font>&nbsp;" . $form_check[error_msg];		
		}
	}


// This creates the breadcrumbs
echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">\n";
echo "<tr>\n";
echo "<td class=\"mnlbreadcrumbs\"><a href=\"index.html\">Home</a> >> Suggest a Category</td>\n";
echo "</tr>\n";
echo "</table>\n";
		
echo "<form method=\"post\" action=\"suggest_cat.php?mode=confirm\">\n";
echo "<table border=\"0\" width=\"90%\" cellpadding=\"5\" cellspacing=\"1\" align=\"center\" bgcolor=\"" . $CONFIG_VAR['form_line_colour'] . "\">\n";

//User message
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td colspan=\"2\" class=\"tbody\">" . $user_message . "</td>\n";
echo "</tr>\n";

//category
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Category:</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"category\" value=\"$category\" size=\"30\" maxlength=\"100\" class=\"forms\">\n";
echo "</td>\n";
echo "</tr>\n";

//Email field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Your Email Address (Optional): </b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"user_email\" value=\"$user_email\" size=\"30\" maxlength=\"50\" class=\"forms\"></td>\n";
echo "</tr>\n";

echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">";
echo "<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Submit Category\" class=\"buttons\"></td>";
echo "</tr>";
echo "</table>";
echo "</form>";

//This creates the search form
search_form ( "index" );

//This creates the main menu along the bottom of the main column
navigation( "index", "", "" );

echo "</td>\n";
echo "<!-- End of the middle_column -->\n\n";

// This creates the right hand menu column
require ( "templates/mnl_right_hand_column.php" );

// This ends the main body table
echo "</tr>\n";
echo "</table>\n";

//This creates the page footer
require ( "templates/mnl_page_footer.php" );
?>