<?php
//
// +----------------------------------------------------------------------+
// | cpLinks - Links Engine
// | http://www.webresourceindex.com
// | Full licence details can be found at http://www.webresourceindex.com 
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Media Netrix Limited  - http://www.medianetrix.com
// +----------------------------------------------------------------------+
// | THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// | AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// | MEDIA NETRIX LIMITED OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
// | BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// | USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// | ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// | 
// | THE PROGRAM MAY NOT BE SOLD OR RE-SOLD WITHOUT THE EXPLICIT AND WRITTEN 
// | PERMISSION OF MEDIA NETRIX LIMITED.
// |
// | MODIFIED PROGRAM CODES MAY NOT BE PUBLICISED, DISTRIBUTED OR SOLD IN ANY MANNER. 
// +----------------------------------------------------------------------+
// | suggest_link.php version history:
// | version 1.0 01/06/2004
// +-----------------------------------------------------------------------+
// |
// | Should you require bespoke modifications to cpLinks, please contact us at
// | cplinks@medianetrix.com
// |
// +========================================================================+

require ( "version.php" );
require ( "config.php" );
require ( "global_config.php" );
require ( "includes/mysql.php" );
require ( "static_generator/common.php" );

global $db;

function display_link_message( $page_width )
	{
	show_message ( "Submit a link", "Please navigate to the category and sub category that you want to add a link for and then select the \"Submit a Link\" from the menu<br><br>If the correct category or sub category doesn't exist, then please select \"Suggest a Category\" (or sub category) and fill in the form. We will then add your category or sub category to the directory.<br><br>You may add links in as many categories as you wish.<br><br>" );
	die;	
	}


function check_form ( $link_type, $title, $website_url, $return_url, $description, $user_email )
	{

	$result = check_field ( $title, "Link Title", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	

	if ( $website_url == "http://" )
		{
        return array('error' => true, 'error_msg' => "Please supply a URL for your website" );
		}

	$result = check_field ( $website_url, "Your website URL", 1, 100 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }

	if ( $link_type == "partner" )
		{
		if ( $return_url == "http://" )
			{
			return array('error' => true, 'error_msg' => "Please supply a URL for your reciprocal link" );
			}

		$result = check_field ( $website_url, "The URL of your reciprocal link", 1, 100 );
		if ( $result[error] == true )
			{
			return array('error' => true, 'error_msg' => $result[error_msg] );
			}		
		}

	$result = check_field ( $description, "Your Description", 1, 250 );
    if ( $result[error] == true )
        {
        return array('error' => true, 'error_msg' => $result[error_msg] );
        }
	
	if ( $user_email != "" )
		{
		$result = validate_email ( $user_email );
		if ( $result == false )
			{
			return array('error' => true, 'error_msg' => "Your email address must be valid" );
			}
		}

	return array('error' => false, 'error_msg' => "" );	
	}

$cat		= $_GET['cat'];
$sub_cat	= $_GET['sub_cat'];
$mode		= $_GET['mode'];

$category_name		= str_replace ( "_", " ", $cat ); 
$sub_category_name	= ucwords ( str_replace ( "_", " ", $sub_cat ) );

$title		= $CONFIG_VAR['website_name'] . " :: Submit a link";
$keyword	= "";
$decription	= "";

//This creates the page header
require ( "templates/mnl_page_header.php" );

// This creates the start of the main body table
echo "<!-- Start of main body table -->\n\n";

echo "<table width=\"" . $CONFIG_VAR['body_width_value'] . "\" align=\"" . $CONFIG_VAR['main_body_align'] . "\" cellspacing=\"0\" border=\"0\" cellpadding=\"0\" bgcolor=\"#" . $CONFIG_VAR['main_body_colour'] . "\">\n";
echo "<tr>\n";

//This creates the left hand column	
require ( "templates/mnl_left_hand_column.php" );

// This creates the middle table
echo "<!-- Start of middle column -->\n\n";
echo "<td valign=\"top\">\n";

$user_message = "Please fill in all the fields that are not marked \"(Optional)\"";

if ( $mode != "confirm" )
	{
	if ( $cat == "" )
		{
		display_link_message( $page_width )	;
		}

	if ( $sub_cat == "" )
		{
		display_link_message( $page_width );
		}
	}


if ( $mode == "confirm" )
	{
    // trim the input variables
	$link_type		= $_POST['link_type'];
	$link_title		= $_POST['link_title'];
	$website_url	= $_POST['website_url'];
	$return_url		= $_POST['return_url'];
	$description	= trim ( $_POST['description'] );
	$user_email		= $_POST['user_email'];

    $form_check = check_form ( $link_type, $link_title, $website_url, $return_url, $description, $user_email );
    if ( $form_check[error] == false )
        {
		// Add this record to the mnl_links table
        $date_added = date( "j F Y" );
        $timestamp = time();

		$query = "INSERT INTO mnl_links (
						category,
						sub_category,
						title,
						url,
						description,
						email,
						return_url,
						date_added,
						rec_timestamp,
						status )

					VALUES (
						'$cat',
						'$sub_cat',
						'$link_title',
						'$website_url',
						'$description',
						'$user_email',
						'$return_url',
						'$date_added',
						'$timestamp',
						'$link_type')";

		$db->query ( $query );
		$link_id = $db->insert_id;

		if ( $CONFIG_VAR['send_webmaster_email'] == "yes" )
			{
			// send an email to us about the new listing
			$mail_subject = "New link submitted for " . $CONFIG_VAR['website_name'];
			$mail_body = "Link Record Number: " . $link_id . "\n\n";
			$mail_body .= "Link Type: " . $link_type . "\n\n";
			$mail_body .= "Category: " . $cat . "\n\n";
			$mail_body .= "Sub category: " . $sub_cat . "\n\n";
			$mail_body .= "Link URL: " . $website_url . "\n\n";
			$mail_body .= "Return URL: " . $return_url . "\n\n";
			$mail_body .= "Email Address: " . $user_email . "\n\n";
			$mail_header = "From: " . $CONFIG_VAR['webmaster_email'] . "\r\n";

			mail ( $CONFIG_VAR['webmaster_email'], $mail_subject, $mail_body , $mail_header );
			}

		// display the thank you
		$message = "Your link has been submitted and we will approve it as soon as possible.";

		if ( $user_email != "" )
			{
			$message .= "<br><br>We will contact you at the email address that you've just supplied (" . $user_email . ") once your category has been approved.";
			}

		if ( $link_type == "partner" )
			{
			$message .= "<br><br>Please note that we periodically check reciprocal links and automatically revert sites that fail to display a link back to us at the URL you've just specified (" . $return_url . ") to Regular listing status.";
			}

		show_message ( "Thank You", $message );
		die;

		}
	else
		{
		$user_message = "<font color=\"red\"><b>SLIGHT PROBLEM:</b></font>&nbsp;" . $form_check[error_msg];		
		}
	}

// This creates the breadcrumbs
echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">\n";
echo "<tr>\n";
echo "<td class=\"mnlbreadcrumbs\"><a href=\"index.html\">Home</a> >> Submit a Link</td>\n";
echo "</tr>\n";
echo "</table>\n";

// This PHP include creates the introductory text to your links submittal form
require ( "templates/mnl_submit_link_text.php" );

echo "<form method=\"post\" action=\"suggest_link.php?mode=confirm&amp;cat=" . $cat . "&amp;sub_cat=" . $sub_cat . "\">\n";
echo "<table border=\"0\" width=\"90%\" cellpadding=\"5\" cellspacing=\"1\" align=\"center\" bgcolor=\"" . $CONFIG_VAR['form_line_colour'] . "\">\n";


//User message
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td colspan=\"2\" class=\"tbody\">$user_message</td>\n";
echo "</tr>\n";

//Show the category and sub category names again
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>You are submitting a link for:</b></td>\n";
echo "<td width=\"50%\" class=\"tbody\"><b>" . $category_name . " >> " . $sub_category_name . "</b></td>\n";
echo "</tr>\n";

//Type of link
$partner_checked = "";
$regular_checked = " checked";

if ( $link_type == "partner" )
	{
	$partner_checked = " checked";
	$regular_checked = "";
	}

echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Type of Link:</b></td>\n";
echo "<td width=\"50%\" class=\"tbody\">Regular <input type=\"radio\" name=\"link_type\" value=\"regular\"" . $regular_checked . ">";
echo "&nbsp;&nbsp;Link Partner <input type=\"radio\" name=\"link_type\" value=\"partner\"" . $partner_checked . ">";
echo "</td>\n";
echo "</tr>\n";

//Title field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Link Title:</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"link_title\" value=\"$link_title\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

//website url field
if ( $website_url == "" )
	{
	$website_url = "http://";
	}
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>The URL of your website:</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"website_url\" value=\"$website_url\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

//Description field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" valign=\"top\" class=\"tbody\"><b>Description of your site:</b>\n";
echo "<td width=\"50%\"><textarea rows=\"6\" name=\"description\" cols=\"35\" class=\"forms\">" . $description . "</textarea>\n";
echo "</td>\n";
echo "</tr>\n";

//return url field
if ( $return_url == "" )
	{
	$return_url = "http://";
	}
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>The URL of your reciprocal link (Optional):</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"return_url\" value=\"$return_url\" size=\"30\" maxlength=\"100\" class=\"forms\"></td>\n";
echo "</tr>\n";

//Email field field
echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td width=\"50%\" class=\"tbody\"><b>Your Email Address (Optional):</b></td>\n";
echo "<td width=\"50%\"><input type=\"text\" name=\"user_email\" value=\"$user_email\" size=\"30\" maxlength=\"50\" class=\"forms\"></td>\n";
echo "</tr>\n";

echo "<tr bgcolor=\"" . $CONFIG_VAR['form_bgcolour'] . "\">\n";
echo "<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Submit Link\" class=\"buttons\"></td>";
echo "</tr>";
echo "</table>";
echo "</form>";

//This creates the search form
search_form ( "index" );

//This creates the main menu along the bottom of the main column
navigation( "index", $category, $sub_category );

echo "</td>\n";
echo "<!-- End of the middle_column -->\n\n";

// This creates the right hand menu column
require ( "templates/mnl_right_hand_column.php" );

// This ends the main body table
echo "</tr>\n";
echo "</table>\n";

//This creates the page footer
require ( "templates/mnl_page_footer.php" );

?>